//+------------------------------------------------------------------+
//|                                                  stoch cross.mq4 |
//|                                                           .....h |
//|                                                  ibfx forum crew |
//+------------------------------------------------------------------+
#property copyright ".....h"
#property link      "ibfx forum crew"

datetime timeprev=0;

bool EnterLong;
bool ExitLong;
bool EnterShort;
bool ExitShort;

//+------------------------------------------------------------------+
static string      ExpertName = "test copy";
static color   EnterLongColor = Green;
static color  EnterShortColor = Red;
static color    ExitLongColor = Blue;
static color   ExitShortColor = Pink;
static int     MAGICNUMBER    = 0;
static int     EXPIRATION     = 0;
//+------------------------------------------------------------------+



extern double  Lots          =0.1;

extern int     StopLoss      = 30;
extern int     TrailingStop  = 10;
extern int     ProfitTarget  = 30;
extern int     Slippage      = 3;
extern bool    TimeCheck     = false;

extern string  caution       ="-----*** needs higher time frame confirmations ****----";
extern int KPeriod=5;
extern int DPeriod=3;
extern int Slowing=3;
extern int MA_Method = 0; // SMA 0, EMA 1, SMMA 2, LWMA 3
extern int PriceField = 0; // Low/High 0, Close/Close 1

//+------------------------------------------------------------------+
int start()
  {
  

  
  if(timeprev==Time[0]){return(0);}
  timeprev=Time[0];
  if(TimeCheck == true)
  {
  if(Hour()==19 && Minute() == 0)
  {
   if( CountLongs() == 1)  {CloseLongs();}
   if( CountShorts() == 1) {CloseShorts();}
  }
  if(Hour()<7 || Hour()>18){return(0);}
  }

  EnterLong = false;
  ExitLong  = false;
  EnterShort = false;
  ExitShort = false;
  TrailingAlls(0,TrailingStop);

//+------------------------------------------------------------------+
 double fastMAnow = iStochastic(NULL, 0, KPeriod, DPeriod, Slowing,MA_Method, PriceField, MODE_MAIN, 0);
 double fastMAprevious = iStochastic(NULL, 0, KPeriod, DPeriod, Slowing,MA_Method, PriceField, MODE_MAIN, 1);

 double slowMAnow = iStochastic(NULL, 0, KPeriod, DPeriod, Slowing,MA_Method, PriceField, MODE_SIGNAL, 0);
 double slowMAprevious = iStochastic(NULL, 0, KPeriod, DPeriod, Slowing,MA_Method, PriceField, MODE_SIGNAL, 1);
    
//-----------------------------enter long---------------------------
    
    if   ((fastMAnow > slowMAnow) && (fastMAprevious < slowMAprevious))   {EnterLong  = true;}
    
//-----------------------------enter short---------------------------    
    
    
    if   ((fastMAnow < slowMAnow) && (fastMAprevious > slowMAprevious))   {EnterShort  = true;}
    
    
    
    
    

//+------------------------------------------------------------------+

// ENTER LONG CONDITION
if(EnterLong == true && CountLongs()== 0)
{
//CLOSE OPEN ORDER
CloseShorts();
// PLACE THE ORDER
OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,StopLong(Bid,StopLoss),TakeLong(Ask,ProfitTarget),ExpertName,MAGICNUMBER,EXPIRATION,EnterLongColor);
} 
// ENTER SHORT CONDITION
if(EnterShort == true && CountShorts()== 0)
{
//CLOSE OPEN ORDER
CloseLongs();
// PLACE THE ORDER
OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,StopShort(Ask,StopLoss),TakeShort(Bid,ProfitTarget),ExpertName,MAGICNUMBER,EXPIRATION,EnterShortColor);
}

if(ExitLong == true && CountLongs()== 1)
{
//CLOSE OPEN ORDER
CloseLongs();
}
if(ExitShort == true && CountShorts()== 1)
{
//CLOSE OPEN ORDER
CloseShorts();
}

   return(0);
  }

//+------------------------------------------------------------------+
//| Close Long Position                                              |
//+------------------------------------------------------------------+
void CloseLongs()
{
 int trades = OrdersTotal();
 for(int trade=0; trade < trades; trade++)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
  if(OrderSymbol()!=Symbol())
  {
   continue;
  }
  if(OrderType()==OP_BUY)
  {
  OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,ExitLongColor);
  }
 }
}
//+------------------------------------------------------------------+
//| Close Short Position                                             |
//+------------------------------------------------------------------+
void CloseShorts()
{
 int trades = OrdersTotal();
 for(int trade=0; trade < trades; trade++)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
  if(OrderSymbol()!=Symbol())
  {
   continue;
  }
  if(OrderType()==OP_SELL)
  {
   OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,ExitShortColor);
  }
 }//for
}
//+------------------------------------------------------------------+
//| Calculate Stop Long                                              |
//+------------------------------------------------------------------+
double StopLong(double price,int stop)
{
 if(stop==0)
 {
  return(0);
 }
 else
 {
  return(price-(stop*Point));
 }
}
//+------------------------------------------------------------------+
//| Calculate Stop Short                                             |
//+------------------------------------------------------------------+
double StopShort(double price,int stop)
{
 if(stop==0)
 {
  return(0);
 }
 else
 {
  return(price+(stop*Point));
 }
}
//+------------------------------------------------------------------+
//| Calculate Profit Target Long                                     |
//+------------------------------------------------------------------+
double TakeLong(double price,int take)
{
 if(take==0) {  return(0);}
 else        {  return(price+(take*Point));}
}
//+------------------------------------------------------------------+
//| Calculate Profit Target Short                                     |
//+------------------------------------------------------------------+
double TakeShort(double price,int take)
{
 if(take==0) {  return(0);}
 else        {  return(price-(take*Point));}
}
//+------------------------------------------------------------------+
//| Calculate concurrent Long position                               |
//+------------------------------------------------------------------+
int CountLongs()
{
 int count=0;
 int trade;
 int trades=OrdersTotal();
 for(trade=0;trade<trades;trade++)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
  
  if(OrderSymbol()!=Symbol())//||OrderMagicNumber()!=MagicNumber)
   continue;
   
  if(OrderType()==OP_BUY)
   count++;
 }//for
 return(count);
}
//+------------------------------------------------------------------+
//| Calculate concurrent short position                              |
//+------------------------------------------------------------------+
int CountShorts()
{
 int count=0;
 int trade;
 int trades=OrdersTotal();
 for(trade=0;trade<trades;trade++)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
  
  if(OrderSymbol()!=Symbol())//||OrderMagicNumber()!=MagicNumber)
   continue;
   
  if(OrderType()==OP_SELL)
   count++;
 }//for
 return(count);
}
//+------------------------------------------------------------------+
//| Calculates Trailing Stops                                        |
//+------------------------------------------------------------------+
void TrailingAlls(int start,int stop)
{
 int profit;
 double stoptrade;
 double stopcal;
 
 if(stop==0) return;
 
 int trade;
 int trades=;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  if(!OrderSelect(trade,SELECT_BY_POS,MODE_TRADES))
   continue;

  if(OrderSymbol()!=Symbol())
   continue;

  if(OrderType()==OP_BUY)
  {
   profit=NormalizeDouble((Bid-OrderOpenPrice())/Point,0);
   if(profit<start)
    continue;
   stoptrade=OrderStopLoss();
   stopcal=Bid-(stop*Point);
   if(stoptrade==0||(stoptrade!=0&&stopcal>stoptrade))
    OrderModify(OrderTicket(),OrderOpenPrice(),stopcal,OrderTakeProfit(),0,EnterLongColor);
  }//Long
  
  if(OrderType()==OP_SELL)
  {
   profit=NormalizeDouble((OrderOpenPrice()-Ask)/Point,0);
   if(profit<start)
    continue;
   stoptrade=OrderStopLoss();
   stopcal=Ask+(stop*Point);
   if(stoptrade==0||(stoptrade!=0&&stopcal<stoptrade))
    OrderModify(OrderTicket(),OrderOpenPrice(),stopcal,OrderTakeProfit(),0,EnterShortColor);
  }//Shrt
  
 }//for
}